from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo

from Products.EasyBlog.config import *
from Products.EasyBlog.content.EasyBlogBase import EasyBlogBase
from Products.EasyBlog.schemata.SEasyBlogCategories import SEasyBlogCategories
from Products.EasyBlog.interfaces.IEasyBlogCategories import IEasyBlogCategories
from Products.EasyBlog.interfaces.IEasyBlogBase import IEasyBlogBase

class EasyBlogCategories(OrderedBaseFolder, EasyBlogBase):                                                          
    """A folderish type to hold all categories"""

    security = ClassSecurityInfo()
    content_icon          = 'folder_icon.gif'
    meta_type             = 'EasyBlogCategories'
    portal_type           = 'EasyBlogCategories'
    archetype_name        = 'EasyBlogCategories'
    immediate_view        = 'easyblogcategories_view'
    default_view          = 'easyblogcategories_view'
    global_allow          = False    
    filter_content_types  = True
    allowed_content_types = ("EasyBlogCategory", )    
    schema                = SEasyBlogCategories
    
    __implements__ = (IEasyBlogBase.__implements__, IEasyBlogCategories)
    
    aliases = ({'(Default)' : 'easyblogcategories_view', 
                'view'      : 'easyblogcategories_view',
                'base_view' : 'easyblogcategories_view', 
                })
    
def modify_fti(fti):
    for a in fti['actions']:
        if a['id'] in ('edit', 'references', 'metadata'):
            a['visible'] = 0
    return fti
    
registerType(EasyBlogCategories, PROJECTNAME)
