from Products.Archetypes.public import *
from AccessControl import ClassSecurityInfo
from Products.EasyBlog.config import *
from Products.EasyBlog.content.EasyBlogBase import EasyBlogBase
from Products.EasyBlog.schemata.SEasyBlogCategory import SEasyBlogCategory
from Products.EasyBlog.interfaces.IEasyBlogCategory import IEasyBlogCategory
from Products.EasyBlog.interfaces.IEasyBlogBase import IEasyBlogBase

class EasyBlogCategory(BaseContent, EasyBlogBase):                                                          
    """A category to structure a blog entry"""

    security = ClassSecurityInfo()
    content_icon          = 'document_icon.gif'
    meta_type             = 'EasyBlogCategory'
    portal_type           = 'EasyBlogCategory'
    archetype_name        = 'EasyBlogCategory'
    immediate_view        = 'base_view'
    default_view          = 'base_view'
    global_allow          = False
    schema                = SEasyBlogCategory
    _at_rename_after_creation = True    
   
    __implements__ = (BaseContent.__implements__, IEasyBlogBase.__implements__, IEasyBlogCategory)

    security.declareProtected(EasyBlogPermissions.DEL_EASYBLOGCATEGORY, "delete")    
    def delete(self):
        """delete this entry"""    
        # Use own delete method to get rid of "Delete objects"-permission        

        parent = self.aq_inner.aq_parent
        parent._delObject(self.id)

        return self.REQUEST.RESPONSE.redirect(
                    "%s?portal_status_message=%s %s" % 
                    (self.getBlog().absolute_url(), 
                    self.Title(), 
                    "has been deleted."))
                
registerType(EasyBlogCategory, PROJECTNAME)
