from Interface import Interface
from DateTime import DateTime

class IEasyBlog(Interface):
    """A Weblog - Holds all other objects of the blog"""
    
    def getCategoriesAsDicts():
        """Returns a list of dicts with serveral informations (id, title, 
           amount of entries) of categories"""

    def getCategoriesAsDL():
        """Returns the categories as DefinitionList"""        

    def getCategoryById(id):
        """Returns the category by the passed id"""
        
    def getPatternsToReviewTrackbacks():
        """Returns the patterns. Resolves a possible link to review trackbacks 
           patterns"""

    def getPatternsToReviewComments():
        """Returns the patterns. Resolves a possible link to review comments 
           patterns"""
        
    def getEntriesPerDay(category="", start = DateTime("1900/01/01"), end = DateTime("2100/01/01"), path="/"):
        """Returns the blogs entries grouped by day - used in per-day-view"""
        
    def getTitleString():
        """Returns the title string dependend on called categoriy resp. date"""
