from Interface import Interface

class IEasyBlogEntry(Interface):
    """Represents a entry within EasyBlog"""

    def getDefaultForAutodetectTrackbacks():
        """Get the default value for autodetect trackbacks from the blog"""
        
    def showCommentsInView():
        """Returns the value for show comments"""        

    def allowCommentsInView():
        """Returns the value for allow comments"""        

    def showTrackbacksInView():
        """Returns the value for show trackbacks"""                

    def receiveTrackbacksInView():
        """Returns the value for receive comments"""        

    def getTrackbackLog():
        """Returns an EasyLogger"""

    def setUpdateDate(dummy):
        """Sets update date always to 'no_update'"""

    def setEntryDate(date):
        """Sets the date dependend on the user's selection"""                
       
    def Date():
        """Returns the date which is responsible for sorting and calendaring"""
        
    def start():
        """Start date of the entry, needed for portal_calendar"""

    def end():
        """End date of the entry (same as start), needed for portal_calendar"""

    def getAmountOfComments():
        """Get the amount of comments which are associated with this entry"""

    def getAmountOfTrackbacks():
        """Get the amount of trackbacks which are associated with this entry"""

    def getEntryCategories():
       """returns only categories which still exists"""
               
    def sendTrackbacks():
        """Delegates sending trackbacks to TrackbackManager""" 
        
    def delete():
        """delete this entry"""
