from Products.Archetypes.public import *

dl_tags = DisplayList()
dl_tags.add('allowed_tags', 'Allowed')
dl_tags.add('disallowed_tags', 'Disallowed')

dl_attributes = DisplayList()
dl_attributes.add('allowed_attributes', 'Allowed')
dl_attributes.add('disallowed_attributes', 'Disallowed')

dl_sendMail = DisplayList()
dl_sendMail.add('comments', 'Comments')
dl_sendMail.add('trackbacks', 'Trackbacks')

dl_roles = DisplayList()
dl_roles.add('Anonymous', 'Anonymous')
dl_roles.add('Member', 'Member')

SEasyBlog = BaseSchema + Schema((
  TextField(
    name   = 'description',    
    widget = TextAreaWidget(
      label             = 'Description',
      description       = "A brief description of the item.",
      i18n_domain       = 'plone',
      description_msgid = 'help_description',
      label_msgid       = 'label_description',
      cols              = 80,            
      rows              = 5,
      )
    ),
  BooleanField(
    name   = "showTitle",
    default = True,
    widget = BooleanWidget(
      label             = 'Show Title',
      description       = "Decides, wheather the title is shown or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showtitle_description',
      label_msgid       = 'easyblog_showtitle_label',
      )
    ),      
  BooleanField(
    name   = "showDocumentActions",
    default = True,
    widget = BooleanWidget(
      label             = 'Show Document Actions',
      description       = "Decides, wheather the documenta actions are shown or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showdocumentactions_description',
      label_msgid       = 'easyblog_showdocumentactions_label',
      )
    ),      
  BooleanField(
    name   = "showDescription",
    default = True,
    widget = BooleanWidget(
      label             = 'Show Description',
      description       = "Decides, wheather the description is shown or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showdescription_description',
      label_msgid       = 'easyblog_showdescription_label',
      )
    ),      
  BooleanField(
    name     = 'showDocumentByLine',
    default  = True,      
    widget   = BooleanWidget(
      label             = "Show Author",                                   
      description       = "Decides, wheather the by-line is shown or not.",
      i18n_domain       = "easyblog",                                   
      label_msgid       = "easydocument_showdocumentbyline_label",                                   
      description_msgid = "easydocument_showdocumentbyline_description",            
      )
    ),      
  IntegerField(
    name   = 'maxEntries',
    default = 5,
    schemata = "Entries",
    widget = IntegerWidget(
      label             = 'Maximal Entries',
      description       = "Decides how much entries should maximal displayed. (Except for category or archive view.)",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_maxentries_description',
      label_msgid       = 'easyblog_maxentries_label',
      )
    ),  
  IntegerField(
    name   = 'maxLastEntries',
    default = 8,
    schemata = "Entries",    
    widget = IntegerWidget(
      label             = 'Maximal Last Entries',
      description       = "Decides how much last entries should maximal displayed in the portlet.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_maxlastentries_description',
      label_msgid       = 'easyblog_maxlastentries_label',
      )
    ),    
  BooleanField(
    name   = "showComments",
    default = True,
    schemata = "Comments",
    widget = BooleanWidget(
      label             = 'Show Comments',
      description       = "Decides weather comments are displayed or not. (Default value, could be changed for every entry.)",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showcomments_description',
      label_msgid       = 'easyblog_showcomments_label',
      )
    ),  
  BooleanField(
    name   = "allowComments",
    default = True,
    schemata = "Comments",
    widget = BooleanWidget(
      label             = 'Allow Comments',
      description       = 'Decides weather adding comments to an entry is allowed or not. Takes only effect if "Show Comments" is yes. (Default value, could be changed for every entry.)',
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_allowcomments_description',
      label_msgid       = 'easyblog_allowcomments_label',
      )
    ),  
  BooleanField(
    name   = "moderateComments",
    default = False,
    schemata = "Comments",
    widget = BooleanWidget(
      label             = 'Moderate Comments',
      description       = "Decides weather comments for an entry are moderated or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_moderatecomments_description',
      label_msgid       = 'easyblog_moderatecomments_label',
      )
    ),  
  LinesField(
    name     = 'patternsToReviewComments',
    schemata = "Comments",
    widget   = LinesWidget(
      label             = "Always Review Comment",
      description       = "If one of these patterns (Regular Expression) matches, a comment has always to be reviewed. One pattern per line. (Enter '&lt;patterns trackbacks&gt;' to overtake the patterns from the trackbacks tab).",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_patterntoreviewcomment_description",
      label_msgid       = "easyblog_patterntoreviewcomment_label",                                             
      cols              = 80,            
      rows              = 5,          
      )
  ),    
  BooleanField(
    name   = "showCommentPreview",
    default = False,
    schemata = "Comments",
    widget = BooleanWidget(
      label             = 'Show Comment Preview',
      description       = "Decides weather a preview of a comment is displayed before it could be saved.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showcommentpreview_description',
      label_msgid       = 'easyblog_showcommentpreview_label',
      )
    ),  
  LinesField(
    name     = 'htmlTags',
    schemata = "Comments",
    widget   = LinesWidget(
      label             = "HTML Tags",                                   
      description       = "Decides which HTML tags are allowed/disallowed within a comment, i.e.: &lt;img&gt;, &lt;a&gt;, etc. One tag per line.",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_htmltags_description",
      label_msgid       = "easyblog_htmltags_label",                                             
      cols              = 80,            
      rows              = 5,          
      )
    ),
  StringField(
    name = "htmlTagsHandling",
    schemata = "Comments",
    vocabulary = dl_tags,
    default = 'allowed_tags',
    widget = SelectionWidget(
      label = "Tags handling",
      description       = "Decides weather the above HTML tags are allowed or disallowed.",
      i18n_domain       = "easyblog",
      description_msgid = "easyblog_htmltagshandling_description",
      label_msgid       = "easyblog_htmltagshandling_label",
      format = "radio",      
      )
    ),
  LinesField(
    name     = 'htmlAttributes',
    schemata = "Comments",
    widget   = LinesWidget(
      label             = "HTML attributes",                                   
      description       = "Decides which HTML attributes are allowed/disallowed within a comment, i.e. style, href, etc. One Attribute per line.",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_htmlattributes_description",
      label_msgid       = "easyblog_htmlattributes_label",                                             
      cols              = 80,            
      rows              = 5,          
      )
    ),
  StringField(
    name = "htmlAttributesHandling",
    schemata = "Comments",
    vocabulary = dl_attributes,
    default = 'allowed_attributes',
    widget = SelectionWidget(
      label = "Attributes handling",
      description       = "Decides weather the above HTML attributes are allowed or disallowed.",
      i18n_domain       = "easyblog",
      description_msgid = "easyblog_attributeshandling_description",
      label_msgid       = "easyblog_attributeshandling_label",
      format = "radio",      
      )
    ),
  BooleanField(
    name   = "showTrackbacks",
    default = True,
    schemata = "Trackbacks",
    widget = BooleanWidget(
      label             = 'Show Trackbacks',
      description       = "Decides weather trackbacks are displayed or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_showtrackbacks_description',
      label_msgid       = 'easyblog_showtrackbacks_label',
      )
    ),  
  BooleanField(
    name   = "receiveTrackbacks",
    default = True,
    schemata = "Trackbacks",
    widget = BooleanWidget(
      label             = 'Receive Trackbacks',
      description       = "Decides weather receiving of trackbacks are allowed or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_receivetrackbacks_description',
      label_msgid       = 'easyblog_receivetrackbacks_label',
      )
    ),  
  BooleanField(
    name   = "moderateTrackbacks",
    default = False,
    schemata = "Trackbacks",
    widget = BooleanWidget(
      label             = 'Moderate Trackbacks',
      description       = "Decides weather received trackbacks for an entry are moderated or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_moderatetrackbacks_description',
      label_msgid       = 'easyblog_moderatetrackbacks_label',
      )
    ),  
  LinesField(
    name     = 'patternsToReviewTrackbacks',
    schemata = "Trackbacks",
    default  = "<patterns review comments>",
    widget   = LinesWidget(
      label             = "Always Review Trackback",
      description       = "If one of these patterns (Regular Expression) matches, a trackback has always to be reviewed. One pattern per line. (Enter '&lt;patterns comments&gt;' to overtake the patterns from the comments tab).",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_patterntoreviewtrackback_description",
      label_msgid       = "easyblog_patterntoreviewtrackback_label",                                             
      cols              = 80,            
      rows              = 5,          
      )
  ),        
  BooleanField(
    name   = "autodetectTrackbacks",
    default = True,
    schemata = "Trackbacks",
    widget = BooleanWidget(
      label             = 'Autodetect Trackbacks',
      description       = 'Decides weather autodetection of urls and send trackbacks is on or off. (Default value, could be changed for every entry.)',
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_autotrackback_description',
      label_msgid       = 'easyblog_autotrackback_label',
      )
    ),  
  IntegerField(
    name   = "maxCharsInTrackbacks",
    default = 100,
    schemata = "Trackbacks",
    widget = IntegerWidget(
      label             = 'Maximal Chars',
      description       = "Decides how much chars will displayed maximal of an received trackback's excerpt (Zero for everything).",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblog_maxcharsintrackbacks_description',
      label_msgid       = 'easyblog_maxcharsintrackbacks_label',
      )
    ),    
  LinesField(
    name     = 'sendNotification',
    schemata = "Notifications",
    vocabulary = dl_sendMail,
    widget   = MultiSelectionWidget(
      label             = "Send Notification",                                   
      description       = "Decides weather a notification mail will be sent after a comment/trackback was added.",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_sendnotification_description",
      label_msgid       = "easyblog_sendnotification_label",                                             
      cols              = 80,            
      rows              = 5,         
      format            = "checkbox",
      )
    ),    
  StringField(
    name = 'notifyFrom',
    schemata = "Notifications",
    widget = StringWidget(
      label             = 'Notify From',                
      i18n_domain       = 'easyblog',
      description       = "Sender of the notification mail.",
      description_msgid = 'easyblog_notifyfrom_description',                               
      label_msgid       = 'easyblog_notifyfrom_label',                            
      size              = 40,
      )
    ),          
  LinesField(
    name     = 'notifyTo',
    schemata = "Notifications",
    widget   = LinesWidget(
      label             = "Notify To",                                   
      description       = "Receiver(s) of the notification mail. One e-mail address per line.",
      i18n_domain       = "easyblog",                                   
      description_msgid = "easyblog_notifyto_description",
      label_msgid       = "easyblog_notifyto_label",                                             
      cols              = 80,            
      rows              = 5,          
      )
    ),        
))
