from Products.Archetypes.public import *

dl_updateDate = DisplayList()
dl_updateDate.add('no_update', 'No update')
dl_updateDate.add('update_to_now', 'Update to now')
dl_updateDate.add('update_to_date', 'Update to date below')

dl_comments = DisplayList()
dl_comments.add("default", "Default")
dl_comments.add("yes", "Enabled")
dl_comments.add("no", "Disabled")

SEasyBlogEntry = BaseSchema + Schema((       
  LinesField(
    name   = "trackbackURLs",
    languageIndependent = 1,
    widget = LinesWidget(
      label             = 'Trackback',
      description       = 'Decides to which URLs trackbacks will be sent. One URL per line.',
      i18n_domain       = 'easyblog',
      label_msgid       = 'easyblogentry_trackbackurls_label',
      description_msgid = 'easyblogentry_trackbackurls_description',      
      )
    ), 
  BooleanField(
    name   = "autodetectTrackbacks",
    default_method = "getDefaultForAutodetectTrackbacks",
    schemata = "default",
    widget = BooleanWidget(
      label             = 'Autodetect Trackbacks',
      description       = "Decides weather autodetect urls within an entry and send trackbacks automatically is on or off.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_showautodetecttrackbacks_description',
      label_msgid       = 'easyblogentry_showautodetecttrackbacks_label',
      )
    ),      
  TextField(
    name   = 'text',
    searchable = True,
    primary = True,
    default_content_type    = 'text/html',
    default_output_type     = 'text/html',
    allowable_content_types = ('text/html',
                               'text/structured',
                               'text/restructured',
                               'text/plain',
                               ),
    widget = RichWidget(
      label             = 'Text',
      description       = 'This text will be fully shown in the entry view and in the blog view.',
      i18n_domain       = 'easyblog',
      label_msgid       = 'easyblogentry_text_label',
      description_msgid = 'easyblogentry_text_description',
      rows = 10,
      )
    ),
  TextField(
    name   = 'more',
    searchable = True,    
    default_content_type    = 'text/html',
    default_output_type     = 'text/html',    
    allowable_content_types = ('text/html',
                               'text/structured',
                               'text/restructured',                                   
                               'text/plain',
                               ),      
    widget = RichWidget(
      label             = 'More',
      description       = 'This text will only be fully shown in the entry view. In the blog view there will be shown a "more"-link',
      i18n_domain       = 'easyblog',
      label_msgid       = 'easyblogentry_more_label',
      description_msgid = 'easyblogentry_more_description',
      rows = 10,
      )
    ),  
  StringField(
    name = "updateDate",
    vocabulary = dl_updateDate,
    default = 'no_update',
    widget = SelectionWidget(
      label             = "Update Date",
      description       = "Decides weather the date is updated or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_updatedate_description',
      label_msgid       = 'easyblogentry_updatedate_label',
      )
    ),    
  DateTimeField(
    name   = 'entryDate',
    default_method = "created",
    languageIndependent = 1,
    widget = CalendarWidget(
      label             = 'EntryDate',
      description       = 'This date will be used for sorting the entries. Default value is the creation date.',
      i18n_domain       = 'easyblog',
      label_msgid       = 'easyblogentry_entrydate_label',
      description_msgid = 'easyblogentry_entrydate_description',      
      )
    ),    
  LinesField(
    name   = "entryCategories",
    index = "KeywordIndex",
    vocabulary = "getCategoriesAsDL",
    required = True,    
    languageIndependent = 1,
    widget = MultiSelectionWidget(
      label             = 'Categories',
      description       = 'Decides under which categories the entry will be grouped.',
      i18n_domain       = 'easyblog',
      label_msgid       = 'easyblogentry_entrycategories_label',
      description_msgid = 'easyblogentry_entrycategories_description',      
      )
    ),
  StringField(
    name   = "showComments",
    vocabulary = dl_comments,
    default = "default",
    schemata = "Comments",
    widget = SelectionWidget(
      label             = 'Show Comments',
	  description       = "Decides weather comments are displayed or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_showcomments_description',
      label_msgid       = 'easyblogentry_showcomments_label',
      format            = "radio",
      )
    ),  
  StringField(    
    name   = "allowComments",
    default = "default",
    schemata = "Comments",    
	vocabulary = dl_comments,
    widget = SelectionWidget(
      label             = 'Allow Comments',
      description       = 'Decides weather adding comments to an entry is allowed or not. (Takes only effect if "Show Comments" is yes).',
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_allowcomments_description',
      label_msgid       = 'easyblogentry_allowcomments_label',
      format            = "radio",
      )
    ),  
  StringField(
    name   = "showTrackbacks",
    vocabulary = dl_comments,
    default = "default",
    schemata = "Trackbacks",
    widget = SelectionWidget(
      label             = 'Show Trackbacks',
	  description       = "Decides weather trackbacks for this entry are displayed or not.",
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_showtrackbacks_description',
      label_msgid       = 'easyblogentry_showtrackbacks_label',
      format            = "radio",
      )
    ),  
  StringField(    
    name   = "receiveTrackbacks",
    default = "default",
    schemata = "Trackbacks",    
	vocabulary = dl_comments,
    widget = SelectionWidget(
      label             = 'Receive Trackbacks',
      description       = 'Decides weather receiving trackbacks for this entry is allowed or not.',
      i18n_domain       = 'easyblog',
      description_msgid = 'easyblogentry_receivetrackbacks_description',
      label_msgid       = 'easyblogentry_receivetrackbacks_label',
      format            = "radio",
      )
    )      
 ), marshall = RFC822Marshaller()
)
