## Script (Python) "get_testeasyblog_ftests"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##

from Products.CMFCore.utils import getToolByName
from DateTime import DateTime

# create date path
date = DateTime()
year = str(date.year())
month = str(date.mm())
day = str(date.dd())
DATE_PATH = "%s/%s/%s" % (year, month, day)

B_TEXT = "That's a entry with a link to &lt;a href='http://localhost:8080/Plone/blog-a/archive/%s/%s/%s/entry-a2' &gt; entry a2&lt;/a&gt;" % (year, month, day)
B_MORE = "That's a entry with a link to &lt;a href='http://localhost:8080/Plone/blog-a/archive/%s/%s/%s/entry-a3' &gt; entry a3&lt;/a&gt;" % (year, month, day)
B_URLS = "http://localhost:8080/Plone/blog-a/archive/%s/%s/%s/entry-a1" % (year, month, day)

selenium = context.portal_selenium

suite = selenium.getSuite()
suite.setTargetLanguage('en')

TestSwitchToLanguage = suite.TestSwitchToLanguage
TestLogout = suite.TestLogout
TestLoginPortlet  = suite.TestLoginPortlet

selenium.addUser(id = 'sampleadmin',fullname='Sample Admin',roles=['Member', 'Manager',])
selenium.addUser(id = 'samplemember',fullname='Sample Member',roles=['Member',])
selenium.addUser(id = 'sampleowner',fullname='Sample Owner',roles=['Member', 'Owner',])
selenium.addUser(id = 'samplereviewer',fullname='Sample Reviewer',roles=['Member', 'Reviewer',])

def AddBlog(title="blog-title", description="description"):
    """Adds A Blog"""
    t = suite.getTest()
    t.open("/folder_delete?paths:list=%s" % title)
    t.open("/folder_contents")
    t.select("select_add_item", "EasyBlog")
    t.clickAndWait("folder_factories:method")
    t.type("title", title)
    t.type("description", description)
    t.clickAndWait("form_submit")
    t.verifyTextPresent("There are no entries.")  
    return t

def PublishBlog(title="blog-title"):
    """Adds A Blog"""
    t = suite.getTest()
    t.open("/%s/content_status_modify?workflow_action=make_public" % title)
    return t

def TestBlog(blog="blog-title"):
    t = suite.getTest()
    t.open("/%s/folder_contents" % blog)
    t.verifyTextPresent("Archive")  
    t.verifyTextPresent("Drafts")  
    t.verifyTextPresent("Categories")  
    return t

def AddFolder(blog="blog-title", title="folder-title", description="description"):
    """Add Folder To Blog"""
    t = suite.getTest()
    t.open("/%s/folder_delete?paths:list=%s" % (blog, title))
    t.open("/%s/folder_contents" % blog)
    t.clickAndWait("folder_factories:method")
    t.type("title", title)
    t.type("description", description)
    t.clickAndWait("form_submit")
    t.open("/%s/folder_contents" % blog)    
    return t

def AddCategory(blog="blog-title", title="category-title"):
    """Add Category To Blog"""
    t = suite.getTest()
    t.open("/%s/categories/folder_delete?paths:list=/Plone/%s/categories/%s" % (blog, blog, title))
    t.open("/%s/categories/createObject?type_name=EasyBlogCategory" % blog)
    t.type("title", title)
    t.clickAndWait("form_submit")
    t.open("/%s/categories" % blog)
    return t 

def AddEntry(blog="blog-title", title="entry-title", text="text", more="more", tb_urls=""):
    """Add Entry To Blog"""
    t = suite.getTest()
    t.open("/%s/drafts/folder_delete?paths:list=%s" % (blog, title))
    t.open("/%s/drafts/createObject?type_name=EasyBlogEntry" % blog)
    t.type("title", title)
    t.type("text", text)
    t.type("more", more)
    t.type("trackbackURLs", tb_urls)    
    t.select("entryCategories", "General")    
    t.clickAndWait("form_submit")
    t.open("/%s/drafts/%s/content_status_modify?workflow_action=publish" % (blog, title))
    return t 

def TestTextPresentInBlogAndEntry(blog="blog-title", entry="entry-title", text="Comments"):
    """Tests, weather the given text is present in blog and entry"""
    t = suite.getTest()
    t.open("/%s" % blog)
    t.verifyTextPresent(text),         
    t.open("/%s/archive/%s/%s/" % (blog, DATE_PATH, entry))
    t.verifyTextPresent(text),     
    return t

def TestTextNotPresentInBlogAndEntry(blog="blog-title", entry="entry-title", text="Comments"):
    """Tests, weather the given text is not present in blog and entry"""
    t = suite.getTest()
    t.open("/%s" % blog)
    t.verifyTextNotPresent(text),         
    t.open("/%s/archive/%s/%s/" % (blog, DATE_PATH, entry))
    t.verifyTextNotPresent(text),     
    return t

def MakeEntryCommentsEnabled(blog="blog-title", entry="entry-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/archive/%s/%s/base_edit?fieldset=Comments" % (blog, DATE_PATH, entry))
    t.click("//input[@value='yes']")    
    t.clickAndWait("form_submit")        
    return t

def MakeEntryCommentsDisabled(blog="blog-title", entry="entry-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/archive/%s/%s/base_edit?fieldset=Comments" % (blog, DATE_PATH, entry))
    t.click("//input[@value='no']")    
    t.clickAndWait("form_submit")    
    return t

def MakeBlogCommentsDisabled(blog="blog-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/base_edit?fieldset=Comments" % blog)
    t.click("//input[@id='showComments']")
    t.clickAndWait("form_submit")        
    return t

def MakeEntryTrackbacksEnabled(blog="blog-title", entry="entry-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/archive/%s/%s/base_edit?fieldset=Trackbacks" % (blog, DATE_PATH, entry))
    t.click("//input[@value='yes']")    
    t.clickAndWait("form_submit")    
    return t

def MakeEntryTrackbacksDisabled(blog="blog-title", entry="entry-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/archive/%s/%s/base_edit?fieldset=Trackbacks" % (blog, DATE_PATH, entry))
    t.click("//input[@value='no']")    
    t.clickAndWait("form_submit")    
    return t
    
def MakeBlogTrackbacksDisabled(blog="blog-title"):
    """ """
    t = suite.getTest()
    t.open("/%s/base_edit?fieldset=Trackbacks" % blog)
    t.click("//input[@id='showTrackbacks']")
    t.clickAndWait("form_submit")        
    return t

def AddBlackList(blog="blog-title", word="word"):
    """ """
    t = suite.getTest()
    t.open("/%s/base_edit?fieldset=Comments" % blog)
    t.type("patternsToReviewComments", word)    
    t.clickAndWait("form_submit")
    return t

def AddComment(blog="blog-title", entry="entry-title", name="name", email="email", homepage="homepage", message="message"):
    """ """
    t = suite.getTest()
    t.open("/%s/archive/%s/%s" % (blog, DATE_PATH, entry))
    t.clickAndWait("//input[@value='comment']")
    t.type("name", name)
    t.type("email", email)
    t.type("homepage", homepage)
    t.type("message", message)    
    t.clickAndWait("form.button.Save")    
    return t

def TestTrackback(blog="blog-title", entry="entry-title"):
    """Test weather the Trackback is created"""
    t = suite.getTest()
    t.open("/%s/archive/%s/%s" % (blog, DATE_PATH, entry))
    t.verifyTextPresent("That's a entry with a link to  entry a2")
    return t	



# --------------------------------------------------------------------------------------------------

suite.addTests('Test Blog',
    'Add A Blog',
    TestSwitchToLanguage('en'),
    TestLoginPortlet('sampleadmin'),          
    AddBlog(), 
    TestBlog(),
    'Add A Folder',
    AddFolder(title="Images"),
    suite.verifyTextPresent("Images"),      
    'Add A Category',
    AddCategory(),
    suite.verifyTextPresent("category-title"),        
    )

suite.addTests('Test Show/Hide Comments',
    'Blog Comments Enabled',    
    TestSwitchToLanguage('en'),
    TestLoginPortlet('sampleadmin'),
    AddBlog(), 
    AddEntry(),    
    TestTextPresentInBlogAndEntry(),
    MakeEntryCommentsEnabled(),
    TestTextPresentInBlogAndEntry(),
    MakeEntryCommentsDisabled(),
    TestTextNotPresentInBlogAndEntry(),
    'Blog Comments Disabled',
    TestLoginPortlet('sampleadmin'),          
    AddBlog(),           
    MakeBlogCommentsDisabled(),
    AddEntry(),          
    TestTextNotPresentInBlogAndEntry(),
    MakeEntryCommentsEnabled(),
    TestTextPresentInBlogAndEntry(),
    MakeEntryCommentsDisabled(),
    TestTextNotPresentInBlogAndEntry(),
    )

suite.addTests('Test Show/Hide Trackbacks',
    'Blog Trackbacks Enabled',
    TestSwitchToLanguage('en'),
    TestLoginPortlet('sampleadmin'),          
    AddBlog(),     
    AddEntry(),
    TestTextPresentInBlogAndEntry(text="Trackbacks"),
    MakeEntryTrackbacksEnabled(),
    TestTextPresentInBlogAndEntry(text="Trackbacks"),
    MakeEntryTrackbacksDisabled(),
    TestTextNotPresentInBlogAndEntry(text="Trackbacks"),
    'Blog Trackbacks Disabled',    
    TestLoginPortlet('sampleadmin'),          
    AddBlog(),           
    MakeBlogTrackbacksDisabled(),
    AddEntry(),          
    TestTextNotPresentInBlogAndEntry(text="Trackbacks"),
    MakeEntryTrackbacksEnabled(),
    TestTextPresentInBlogAndEntry(text="Trackbacks"),
    MakeEntryTrackbacksDisabled(),
    TestTextNotPresentInBlogAndEntry(text="Trackbacks"),    
    )

suite.addTests('Test Blacklist Comments', 
    "Add Blog",
    TestSwitchToLanguage('en'),
    TestLoginPortlet('sampleadmin'),              
    AddBlog(),
    AddBlackList(word="test"),
    AddEntry(),
    PublishBlog(),    
    "Add Comment With Disallowed Word",
    TestSwitchToLanguage('en'),    
    TestLogout(),
    AddComment(message="test"),
    suite.verifyTextPresent("Your comment has been submited and will be published soon."),     
    "Add Comment With Allowed Words",
    TestSwitchToLanguage('en'),    
    TestLogout(),
    AddComment(message="sfsdfsfsf"),
    suite.verifyTextPresent("Your comment has been published."),     
    )

suite.addTests('Test Sending/Reciving Trackbacks',
    'Create Blog A',
    TestSwitchToLanguage('en'),
    TestLoginPortlet('sampleadmin'),          
    AddBlog(title="blog-a"),
    PublishBlog(title="blog-a"),
    'Create Entry A1',
    AddEntry("blog-a", title="entry-a1"),
    'Create Entry A2',
    AddEntry("blog-a", title="entry-a2"),
    'Create Entry A3',
    AddEntry("blog-a", title="entry-a3"),
    'Create Blog B', 
    AddBlog(title="blog-b"),
    'Create Entry B',  
    AddEntry("blog-b", title="entry-b", text=B_TEXT, more=B_MORE, tb_urls=B_URLS),
    'TestTrackbacks', 
    TestTrackback("blog-a", "entry-a1"),
    TestTrackback("blog-a", "entry-a2"),
    TestTrackback("blog-a", "entry-a3"),    
    )
    
return suite
