## Test EasyBlogCategories

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.EasyBlog.tests import EasyBlogTestCase

class TestEasyBlogCategories(EasyBlogTestCase.EasyBlogTestCase):
        
    def testTypeInformation(self):               
        portal_type = self.portal.portal_types        
        type_info = portal_type.getTypeInfo("EasyBlogCategories")
        
        self.assertEqual(type_info.global_allow, False)
        self.assertEqual(type_info.filter_content_types, True)
        self.assertEqual(type_info.allowed_content_types, ("EasyBlogCategory", ))
        self.assertEqual(type_info.content_meta_type, "EasyBlogCategories")

        ## actions
        actions = [a.id for a in type_info._actions]        
        self.assertEqual(actions, ['view', 'edit', 'metadata', 'references', 'folderlisting'])
     
    def testSorting(self):
        self.setRoles(['Manager', ])
        self.folder.invokeFactory("EasyBlog", id="blog", title="Blog")
        self.folder.blog.categories.invokeFactory("EasyBlogCategory", id="A", title="A")
        self.folder.blog.categories.invokeFactory("EasyBlogCategory", id="B", title="B")
        
        self.assertEqual(self.folder.blog.categories.objectIds(), ['general', 'A', 'B'])
        
        self.folder.blog.categories.moveObjectsUp('B')
        self.folder.blog.categories.moveObjectsDown('general')
        
        self.assertEqual(self.folder.blog.categories.objectIds(), ['B', 'general', 'A'])
        
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestEasyBlogCategories))
    return suite

if __name__ == '__main__':
    framework()

