## Test EasyBlogWorkflow

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.EasyBlog.tests import EasyBlogTestCase
from AccessControl import Unauthorized
from Products.CMFCore.utils import transaction

class TestEasyBlog(EasyBlogTestCase.EasyBlogTestCase):

    def afterSetUp(self):
        self.setRoles(['Manager'])
        self.folder.invokeFactory("EasyBlog", id="blog", title="Blog")
        self.blog = self.folder.blog

    def testPublishAndRetractEntry(self):        
        self.folder.blog.drafts.invokeFactory('EasyBlogEntry', id="blogentry", title="Blogentry", text="Text", more="More")        
        # need commit, because entry is cut 'n paste
        transaction.commit(1)             
        workflow = self.portal.portal_workflow
        
        blogentry = self.folder.blog.drafts.blogentry
        workflow.doActionFor(blogentry, "publish")
        
        # entry should be now in archive dependend on creation date
        # so create path elements
        date = blogentry.Date()
        year = str(date.year())
        month = str(date.mm())
        day = str(date.dd())
        
        # get blogentry in archive        
        blogentry = self.folder.blog.archive[year][month][day].blogentry
        
        # retract
        workflow.doActionFor(blogentry, "reject")
        
        # entry should know back in drafts
        self.failUnless("blogentry" in self.folder.blog.drafts.objectIds())

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestEasyBlog))
    return suite

if __name__ == '__main__':
    framework()

