import HTMLParser

class BodyHTMLParser(HTMLParser.HTMLParser):
   """A simple Parser, which returns only the body out of given HTML"""
   def __init__(self):
      self.html = ""
      self.within_body = False
      
      HTMLParser.HTMLParser.__init__(self)
        
   def handle_starttag(self, tag, attrs):
           
      if self.within_body == True:
         self.html += "<%s" % tag
              
         for attr in attrs:
            self.html += ' %s="%s"' % (attr)
              
         self.html += ">"
              
      if tag == "body":
         self.within_body = True
              
           
   def handle_endtag(self, tag):
                      
      if tag == "body":
         self.within_body = False

      if self.within_body:
         self.html += "</%s>" % tag
                
   def handle_data(self, data):
      if self.within_body:
         self.html += data
              
   def handle_startendtag(self, tag, attrs):
           
      if self.within_body == True:
         self.html += "<%s" % tag
              
         for attr in attrs:
            self.html += ' %s="%s"' % (attr)
              
         self.html += " />"
   
   def handle_entityref(self, name):
      self.html += "&%s;" % name


