from AccessControl import ClassSecurityInfo
import Globals

class EasyLogger:
    """A class for easy logging"""

    security = ClassSecurityInfo()

    def __init__(self):
        """Constructor"""
        self.logs = []
            
    def getNewLog(self):
        """Returns a new Log, ready to fill in"""
        new_log = Log()
        self.logs.append(new_log)
        
        return new_log
    
    security.declarePublic('getLogs')
    def getLogs(self):
        """Returns all logs - lifo"""
                
        logs = self.logs
        logs.reverse()
        
        return logs

    security.declarePublic('hasLogs')    
    def hasLogs(self):
        """ """
        if len(self.logs) > 0:
            return True
        
        return False
class Log:
    """A logfile within a EasyLogger"""
    
    security = ClassSecurityInfo()
    
    def __init__(self):
        """Constructor"""       
        self.lines = []
        
    def addTitle(self, content):
        """Adds a title"""      

        new_line = Line("title", content)
        self.lines.append(new_line)
        
    def addLine(self, content):
        """Adds a line with one row"""       

        new_line = Line("line1", content)     
        self.lines.append(new_line)

    def addLine2(self, content1, content2):
        """Adds a line with two rows"""

        new_line = Line("line2", content1, content2)
        self.lines.append(new_line)       
        
    security.declarePublic('getLines')        
    def getLines(self):
        """Returns the log in nice HTML"""
        
        return self.lines
    
class Line: 
    """Represents a Line within a Log"""

    security = ClassSecurityInfo()

    def __init__(self, kindof, content1, content2=""):
        """ """
        self.kindof   = kindof
        self.content1 = content1
        self.content2 = content2
        
    security.declarePublic('getKindof')
    def getKindof(self):
        """ """
        return self.kindof
        
    security.declarePublic('getContent1')        
    def getContent1(self):
        """ """
        return self.content1

    security.declarePublic('getContent2')        
    def getContent2(self):
        """ """
        return self.content2
        
Globals.InitializeClass(EasyLogger)
Globals.InitializeClass(Log)
Globals.InitializeClass(Line)

