import HTMLParser

class RdfHTMLParser(HTMLParser.HTMLParser):
   """A simple Parser to get the trackback:ping URL out of the given html for 
      a certain URL
   		
   	  If a trackback:ping is found for the passed URL it is stored in 
   	  self.tb_url. Otherwise self.tb_url is None"""
   
   def __init__(self, url):
      """My constructor"""
      HTMLParser.HTMLParser.__init__(self)
      self.url = url
      self.tb_url = None
         
   def handle_starttag(self, tag, attrs):
      """Overwritten hook"""
      if tag == "rdf:description":
         attrs = dict(attrs)
         # for the case there are more than one trackback:pings
         if attrs.get("dc:identifier") == self.url:
            self.tb_url = attrs.get("trackback:ping")
         
   def handle_comment(self, data):     
      """Overwritten hook"""
      parser = RdfHTMLParser(self.url)
      parser.feed(data)
      if self.tb_url is None and parser.tb_url is not None:
         self.tb_url = parser.tb_url
