# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: easyblogentry_workflow/EasyBlogEntry Workflow
# Date: 2005/11/15 16:18:04.854 GMT+1
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# The following scripts have been detected and should be backed up:
# - move_to_draft (Script (Python))
# - move_to_archive (Script (Python))
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

import os
from Products.EasyBlog.config import GLOBALS
from Globals import package_home
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.PythonScripts.PythonScript import manage_addPythonScript

# Next two code lines are cribbed from Ploneboard
# path_prefix is used for finding workflow scripts
path_prefix = os.path.join( package_home(GLOBALS), 'workflow_scripts')

# Default is to add all scripts for all workflows
# Override by defining script_ids as a tuple for each workflow
script_ids = [x[:-3] for x in filter(lambda y: y.endswith('.py'), os.listdir(path_prefix))]

def setupEasyblogentry_workflow(wf):
    "..."
    wf.setProperties(title='EasyBlogEntry Workflow')

    for s in ['draft', 'pending', 'published']:
        wf.states.addState(s)
    for t in ['reject', 'submit', 'retract_form_published', 'retract_from_pending', 'publish']:
        wf.transitions.addTransition(t)
    for v in []:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View', 'EasyBlog: Delete EasyBlogEntry'):
        wf.addManagedPermission(p)
        
    # cribbed from Ploneboard
    for script_id in script_ids:
        manage_addPythonScript(wf.scripts, script_id)
        scr = getattr(wf.scripts, script_id)
        scr.write(open(os.path.join(path_prefix, '%s.py' % script_id)).read())

    ## Initial State
    wf.states.setInitialState('draft')

    ## States initialization
    sdef = wf.states['draft']
    sdef.setProperties(title="""Visible but not published""",
                       transitions=('publish', 'submit'))
    sdef.setPermission('Access contents information', 0, ['EasyBlogReviewer', 'Manager', 'Owner', 'Reviewer'])
    sdef.setPermission('Modify portal content', 0, ['Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Manager', 'Owner'])
    sdef.setPermission('EasyBlog: Delete EasyBlogEntry', 0, ['Manager', 'Owner'])

    sdef = wf.states['pending']
    sdef.setProperties(title="""Waiting for reviewer""",
                       transitions=('publish', 'reject', 'retract_from_pending'))
    sdef.setPermission('Access contents information', 0, ['EasyBlogReviewer', 'Manager', 'Owner', 'Reviewer'])
    sdef.setPermission('Modify portal content', 0, ['EasyBlogReviewer', 'Manager', 'Reviewer'])
    sdef.setPermission('View', 0, ['EasyBlogReviewer', 'Manager', 'Owner', 'Reviewer'])
    sdef.setPermission('EasyBlog: Delete EasyBlogEntry', 0, ['Manager', 'Owner'])

    sdef = wf.states['published']
    sdef.setProperties(title="""Public""",
                       transitions=('reject', 'retract_form_published'))
    sdef.setPermission('Access contents information', 1, ['EasyBlogReviewer', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['EasyBlogReviewer', 'Manager'])
    sdef.setPermission('View', 1, ['EasyBlogReviewer', 'Manager', 'Owner'])
    sdef.setPermission('EasyBlog: Delete EasyBlogEntry', 0, ['EasyBlogReviewer', 'Manager'])


    ## Transitions initialization
    tdef = wf.transitions['reject']
    tdef.setProperties(title="""Reviewer rejects submission""",
                       new_state_id="""draft""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""move_to_draft""",
                       actbox_name="""Reject""",
                       actbox_url="""%(content_url)s/content_reject_form""",
                       actbox_category="""workflow""",
                       props={'guard_expr': 'python:here.isAllowedToReviewBlog()'},
                       )

    tdef = wf.transitions['submit']
    tdef.setProperties(title="""Member requests publishing""",
                       new_state_id="""pending""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Submit""",
                       actbox_url="""%(content_url)s/content_submit_form""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Request review'},
                       )

    tdef = wf.transitions['retract_form_published']
    tdef.setProperties(title="""Reviewer retracts published""",
                       new_state_id="""draft""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""move_to_draft""",
                       actbox_name="""Retract""",
                       actbox_url="""%(content_url)s/content_retract_form""",
                       actbox_category="""workflow""",
                       props={'guard_expr': 'python:here.isAllowedToReviewBlog()'},
                       )

    tdef = wf.transitions['retract_from_pending']
    tdef.setProperties(title="""Member retracts submission""",
                       new_state_id="""draft""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""move_to_draft""",
                       actbox_name="""Retract""",
                       actbox_url="""%(content_url)s/content_retract_form""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Request review'},
                       )

    tdef = wf.transitions['publish']
    tdef.setProperties(title="""Reviewer publishes content""",
                       new_state_id="""published""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""move_to_archive""",
                       actbox_name="""Publish""",
                       actbox_url="""%(content_url)s/content_publish_form""",
                       actbox_category="""workflow""",
                       props={'guard_expr': 'python:here.isAllowedToReviewBlog()'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'EasyBlog: Review Blog', 'var_match_review_state': 'pending'})

def createEasyblogentry_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupEasyblogentry_workflow(ob)
    return ob

def install():
    addWorkflowFactory(createEasyblogentry_workflow,
                       id='easyblogentry_workflow',
                       title='EasyBlogEntry Workflow')
