# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: easyblogtrackback_workflow/EasyBlogTrackback Workflow
# Date: 2005/10/19 12:35:13.049 GMT+2
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupEasyblogtrackback_workflow(wf):
    "..."
    wf.setProperties(title='EasyBlogTrackback Workflow')

    for s in ['editable', 'pending', 'published']:
        wf.states.addState(s)
    for t in ['retract', 'submit', 'publish']:
        wf.transitions.addTransition(t)
    for v in []:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Modify portal content',):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('editable')

    ## States initialization
    sdef = wf.states['editable']
    sdef.setProperties(title="""not published and editable""",
                       transitions=('publish', 'submit'))
    sdef.setPermission('Modify portal content', 0, ['Anonymous', 'Manager'])

    sdef = wf.states['pending']
    sdef.setProperties(title="""not published and not editable""",
                       transitions=('publish',))
    sdef.setPermission('Modify portal content', 0, ['Reviewer', 'Manager'])

    sdef = wf.states['published']
    sdef.setProperties(title="""published and not editable""",
                       transitions=('retract',))
    sdef.setPermission('Modify portal content', 0, ['Manager'])


    ## Transitions initialization
    tdef = wf.transitions['retract']
    tdef.setProperties(title="""""",
                       new_state_id="""pending""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Retract""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Review portal content'},
                       )

    tdef = wf.transitions['submit']
    tdef.setProperties(title="""""",
                       new_state_id="""pending""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Submit""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'View'},
                       )

    tdef = wf.transitions['publish']
    tdef.setProperties(title="""""",
                       new_state_id="""published""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Publish""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_expr': "python: here.getBlog().getModerateTrackbacks()==False or here.portal_membership.getAuthenticatedMember().has_role('Manager')", 'guard_permissions': 'View'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'Review portal content', 'var_match_review_state': 'pending'})


def createEasyblogtrackback_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupEasyblogtrackback_workflow(ob)
    return ob

def install():
	addWorkflowFactory(createEasyblogtrackback_workflow,
					   id='easyblogtrackback_workflow',
					   title='EasyBlogTrackback Workflow')

