# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: easyblog_workflow/EasyBlog Workflow
# Date: 2005/11/28 13:03:02.137 GMT+1
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupEasyblog_workflow(wf):
    "..."
    wf.setProperties(title='EasyBlog Workflow')

    for s in ['closed', 'private', 'public']:
        wf.states.addState(s)
    for t in ['make_closed', 'make_private', 'make_public']:
        wf.transitions.addTransition(t)
    for v in []:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'View'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('private')

    ## States initialization
    sdef = wf.states['closed']
    sdef.setProperties(title="""For Members Only""",
                       transitions=('make_private', 'make_public'))
    sdef.setPermission('Access contents information', 0, ['Manager', 'Member', 'Owner'])
    sdef.setPermission('View', 0, ['Manager', 'Member', 'Owner'])

    sdef = wf.states['private']
    sdef.setProperties(title="""Private""",
                       transitions=('make_closed', 'make_public'))
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner'])
    sdef.setPermission('View', 0, ['Manager', 'Owner'])

    sdef = wf.states['public']
    sdef.setProperties(title="""Free For All""",
                       transitions=('make_closed', 'make_private'))
    sdef.setPermission('Access contents information', 1, ['Anonymous', 'Authenticated', 'Manager', 'Member', 'Owner', 'Reviewer'])
    sdef.setPermission('View', 1, ['Anonymous', 'Authenticated', 'Manager', 'Member', 'Owner', 'Reviewer'])


    ## Transitions initialization
    tdef = wf.transitions['make_closed']
    tdef.setProperties(title="""For Members Only""",
                       new_state_id="""closed""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make Closed""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['make_private']
    tdef.setProperties(title="""For Owner Only""",
                       new_state_id="""private""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make Private""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    tdef = wf.transitions['make_public']
    tdef.setProperties(title="""Free For All""",
                       new_state_id="""public""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Make Public""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Manager'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    ## Worklists Initialization

def createEasyblog_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupEasyblog_workflow(ob)
    return ob

def install():
    addWorkflowFactory(createEasyblog_workflow,
                       id='easyblog_workflow',
                       title='EasyBlog Workflow')

